#include <windows.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <gl\glaux.h>
#include "resource\resource.h"

//======================Handles================================================//
HINSTANCE hInst; // main function handler
#define WIN32_LEAN_AND_MEAN // this will assume smaller exe
//========================================
HWND GlWindow;
HDC hDC;
HGLRC hRC;
GLfloat rotate;

VOID EnableOpenGL( HWND hWnd, HDC * hDC, HGLRC * hRC );
VOID DisableOpenGL( HWND hWnd, HDC hDC, HGLRC hRC );

// Enable OpenGL

VOID EnableOpenGL( HWND hWnd, HDC * hDC, HGLRC * hRC )
{
   PIXELFORMATDESCRIPTOR pfd;
   int iFormat;

   // get the device context (DC)
   *hDC = GetDC( hWnd );

   // set the pixel format for the DC
   ZeroMemory( &pfd, sizeof( pfd ) );
   pfd.nSize = sizeof( pfd );
   pfd.nVersion = 1;
   pfd.dwFlags = PFD_DRAW_TO_WINDOW | 
   PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
   pfd.iPixelType = PFD_TYPE_RGBA;
   pfd.cColorBits = 24;
   pfd.cDepthBits = 16;
   pfd.iLayerType = PFD_MAIN_PLANE;
   iFormat = ChoosePixelFormat( *hDC, &pfd );
   SetPixelFormat( *hDC, iFormat, &pfd );

   // create and enable the render context (RC)
   *hRC = wglCreateContext( *hDC );
   wglMakeCurrent( *hDC, *hRC );

}

// Disable OpenGL
VOID DisableOpenGL( HWND hWnd, HDC hDC, HGLRC hRC )
{
   wglMakeCurrent( NULL, NULL );
   wglDeleteContext( hRC );
   ReleaseDC( GlWindow, hDC );
} 

//====================MAIN KEYGEN DIALOG==========================================//
BOOL CALLBACK DialogProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) // what are we doing ?
	{ 	 
		// This Window Message is the heart of the dialog //
		//================================================//
		case WM_INITDIALOG: 
		{
           //MSG msg;
           //BOOL bQuit = FALSE;
           GlWindow=GetDlgItem(hWnd,IDC_OPENGL);
		   EnableOpenGL( GlWindow, &hDC, &hRC );         
		}
		break;

        case WM_PAINT:
		{
			glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
            glClear( GL_COLOR_BUFFER_BIT );

            glPushMatrix();
            glRotatef( rotate, 0.0f, 1.0f, 0.0f );
   
           glBegin( GL_TRIANGLES );
             glColor3f( 1.0f, 0.0f, 0.0f ); 
			 glVertex3f( 0.0f, 1.0f, 0.0f );
             glColor3f( 0.0f, 1.0f, 0.0f ); 
			 glVertex3f( 1.0f, -1.0f, 0.0f );
             glColor3f( 0.0f, 0.0f, 1.0f ); 
			 glVertex3f( -1.0f, -1.0f, 0.0f );
           glEnd();
   
           glPopMatrix();

           SwapBuffers( hDC );
		   rotate+=0.2f;
		   return true;
		}
		break;

		case WM_CLOSE:
		{
			EndDialog(hWnd,0);
		}
		break;

		case WM_LBUTTONDOWN: // moving dialog trick with mouse
		{
			ReleaseCapture(); // see above :-)
			SendMessage(hWnd,WM_NCLBUTTONDOWN,HTCAPTION,0); // see above
		}
		break;

		case WM_COMMAND: // Controling the Buttons
		{
			switch (LOWORD(wParam)) // what we pressed on?
			{ 	 
										
				
			}
			break;
		}
		break;
	}
	return 0;
}

//===========================MAIN FUNCTION-WIN32 STARTING POINT========================================//
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
	hInst=hInstance;
	DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), NULL, (DLGPROC)DialogProc,0);
	return 0;
}
//======================================================================================================//